package com.fp.persistence.pgeneral.batch;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que hace referencia a la Clave Primaria de TGENEACCOUNTBATCHPROCESS*/
@Embeddable
public class TgeneAccountBatchProcessKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="ACCOUNT", nullable=false,updatable=false)

/**
* Numero de cuenta
*/
private String account;

@Column(name="COMPANY", nullable=false,updatable=false)

/**
* Codigo de compania a la que pertence la cuenta
*/
private Integer company;

@Column(name="PROCESSDATE", nullable=false,updatable=false)

/**
* Fecha de proceso de la ejecucion del batch.
*/
private Date processdate;

@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="TRANSACTIONMODULE", nullable=false,updatable=false)

/**
* Modulo al que pertence la transaccion
*/
private String transactionmodule;

@Column(name="TRANSACTIONCODE", nullable=false,updatable=false)

/**
* Codigo de transaccion dentro del modulo
*/
private Integer transactioncode;

@Column(name="TRANSACTIONVERSION", nullable=false,updatable=false)

/**
* Version de transaccion
*/
private Integer transactionversion;

@Column(name="ACTIONCODE", nullable=false,updatable=false)

/**
* Codigo de accion a ajecutar, ejm,  CAPITALIZE, CUT
*/
private String actioncode;

/**Contructor por defecto*/
public TgeneAccountBatchProcessKey(){}
/**Contructor de TgeneAccountBatchProcessKey
@param pAccount Numero de cuenta
@param pCompany Codigo de compania a la que pertence la cuenta
@param pProcessdate Fecha de proceso de la ejecucion del batch.
@param pModulecode Codigo de modulo
@param pTransactionmodule Modulo al que pertence la transaccion
@param pTransactioncode Codigo de transaccion dentro del modulo
@param pTransactionversion Version de transaccion
@param pActioncode Codigo de accion a ajecutar, ejm,  CAPITALIZE, CUT
*/
public TgeneAccountBatchProcessKey(String pAccount,Integer pCompany,Date pProcessdate,String pModulecode,String pTransactionmodule,Integer pTransactioncode,Integer pTransactionversion,String pActioncode){
 account=pAccount;
 company=pCompany;
 processdate=pProcessdate;
 modulecode=pModulecode;
 transactionmodule=pTransactionmodule;
 transactioncode=pTransactioncode;
 transactionversion=pTransactionversion;
 actioncode=pActioncode;
}
/**Obtiene el valor de account
@return valor de account*/
public String getAccount(){
  return account;
}
/**Fija el valor de account
@param pAccount nuevo Valor de account*/
public void setAccount(String pAccount){
  account=pAccount;
}

/**Obtiene el valor de company
@return valor de company*/
public Integer getCompany(){
  return company;
}
/**Fija el valor de company
@param pCompany nuevo Valor de company*/
public void setCompany(Integer pCompany){
  company=pCompany;
}

/**Obtiene el valor de processdate
@return valor de processdate*/
public Date getProcessdate(){
  return processdate;
}
/**Fija el valor de processdate
@param pProcessdate nuevo Valor de processdate*/
public void setProcessdate(Date pProcessdate){
  processdate=pProcessdate;
}

/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de transactionmodule
@return valor de transactionmodule*/
public String getTransactionmodule(){
  return transactionmodule;
}
/**Fija el valor de transactionmodule
@param pTransactionmodule nuevo Valor de transactionmodule*/
public void setTransactionmodule(String pTransactionmodule){
  transactionmodule=pTransactionmodule;
}

/**Obtiene el valor de transactioncode
@return valor de transactioncode*/
public Integer getTransactioncode(){
  return transactioncode;
}
/**Fija el valor de transactioncode
@param pTransactioncode nuevo Valor de transactioncode*/
public void setTransactioncode(Integer pTransactioncode){
  transactioncode=pTransactioncode;
}

/**Obtiene el valor de transactionversion
@return valor de transactionversion*/
public Integer getTransactionversion(){
  return transactionversion;
}
/**Fija el valor de transactionversion
@param pTransactionversion nuevo Valor de transactionversion*/
public void setTransactionversion(Integer pTransactionversion){
  transactionversion=pTransactionversion;
}

/**Obtiene el valor de actioncode
@return valor de actioncode*/
public String getActioncode(){
  return actioncode;
}
/**Fija el valor de actioncode
@param pActioncode nuevo Valor de actioncode*/
public void setActioncode(String pActioncode){
  actioncode=pActioncode;
}

/**Implementación de la comparación de TgeneAccountBatchProcessKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneAccountBatchProcessKey))return false;
  TgeneAccountBatchProcessKey that = (TgeneAccountBatchProcessKey) o;
  if (this.getAccount() == null || that.getAccount() == null){
      return false;
  }
  if (! this.getAccount().equals(that.getAccount())){
    return false;
  }
  if (this.getCompany() == null || that.getCompany() == null){
      return false;
  }
  if (! this.getCompany().equals(that.getCompany())){
    return false;
  }
  if (this.getProcessdate() == null || that.getProcessdate() == null){
      return false;
  }
  if (! this.getProcessdate().equals(that.getProcessdate())){
    return false;
  }
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getTransactionmodule() == null || that.getTransactionmodule() == null){
      return false;
  }
  if (! this.getTransactionmodule().equals(that.getTransactionmodule())){
    return false;
  }
  if (this.getTransactioncode() == null || that.getTransactioncode() == null){
      return false;
  }
  if (! this.getTransactioncode().equals(that.getTransactioncode())){
    return false;
  }
  if (this.getTransactionversion() == null || that.getTransactionversion() == null){
      return false;
  }
  if (! this.getTransactionversion().equals(that.getTransactionversion())){
    return false;
  }
  if (this.getActioncode() == null || that.getActioncode() == null){
      return false;
  }
  if (! this.getActioncode().equals(that.getActioncode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneAccountBatchProcessKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getAccount() == null ? 0 : this.getAccount().hashCode());
    result = result * 37 + (this.getCompany() == null ? 0 : this.getCompany().hashCode());
    result = result * 37 + (this.getProcessdate() == null ? 0 : this.getProcessdate().hashCode());
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getTransactionmodule() == null ? 0 : this.getTransactionmodule().hashCode());
    result = result * 37 + (this.getTransactioncode() == null ? 0 : this.getTransactioncode().hashCode());
    result = result * 37 + (this.getTransactionversion() == null ? 0 : this.getTransactionversion().hashCode());
    result = result * 37 + (this.getActioncode() == null ? 0 : this.getActioncode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
